Next: Bug reporting Up: Configuring and Building MLD2P4 Previous: Optional third party libraries Contents

## Configuration options

To build MLD2P4 the first step is to use the `configure` script in the main directory to generate the necessary makefile(s).

As a minimal example consider the following:

    ./configure --with-psblas=PSB-INSTALL-DIR

which assumes that the various MPI compilers and support libraries are available in the standard directories on the system, and specifies only the PSBLAS install directory (note that the latter directory must be specified with an absolute path). The full set of options may be looked at by issuing the command `./configure --help`, which produces:

    `configure' configures MLD2P4 2.0 to adapt to many kinds of systems.

    Usage: ../../configure [OPTION]... [VAR=VALUE]...

    To assign environment variables (e.g., CC, CFLAGS...), specify them as
    VAR=VALUE.  See below for descriptions of some of the useful variables.

    Defaults for the options are specified in brackets.

    Configuration:
      -h, --help              display this help and exit
          --help=short        display options specific to this package
          --help=recursive    display the short help of all the included packages
      -V, --version           display version information and exit
      -q, --quiet, --silent   do not print `checking ...' messages
          --cache-file=FILE   cache test results in FILE [disabled]
      -C, --config-cache      alias for `--cache-file=config.cache'
      -n, --no-create         do not create output files
          --srcdir=DIR        find the sources in DIR [configure dir or `..']

    Installation directories:
      --prefix=PREFIX         install architecture-independent files in PREFIX
                              [/usr/local]
      --exec-prefix=EPREFIX   install architecture-dependent files in EPREFIX
                              [PREFIX]

    By default, `make install' will install all the files in
    `/usr/local/bin', `/usr/local/lib' etc.  You can specify
    an installation prefix other than `/usr/local' using `--prefix',
    for instance `--prefix=$HOME'.

    For better control, use the options below.

    Fine tuning of the installation directories:
      --bindir=DIR            user executables [EPREFIX/bin]
      --sbindir=DIR           system admin executables [EPREFIX/sbin]
      --libexecdir=DIR        program executables [EPREFIX/libexec]
      --sysconfdir=DIR        read-only single-machine data [PREFIX/etc]
      --sharedstatedir=DIR    modifiable architecture-independent data [PREFIX/com]
      --localstatedir=DIR     modifiable single-machine data [PREFIX/var]
      --libdir=DIR            object code libraries [EPREFIX/lib]
      --includedir=DIR        C header files [PREFIX/include]
      --oldincludedir=DIR     C header files for non-gcc [/usr/include]
      --datarootdir=DIR       read-only arch.-independent data root [PREFIX/share]
      --datadir=DIR           read-only architecture-independent data [DATAROOTDIR]
      --infodir=DIR           info documentation [DATAROOTDIR/info]
      --localedir=DIR         locale-dependent data [DATAROOTDIR/locale]
      --mandir=DIR            man documentation [DATAROOTDIR/man]
      --docdir=DIR            documentation root [DATAROOTDIR/doc/mld2p4]
      --htmldir=DIR           html documentation [DOCDIR]
      --dvidir=DIR            dvi documentation [DOCDIR]
      --pdfdir=DIR            pdf documentation [DOCDIR]
      --psdir=DIR             ps documentation [DOCDIR]

    Optional Features:
      --disable-option-checking  ignore unrecognized --enable/--with options
      --disable-FEATURE       do not include FEATURE (same as --enable-FEATURE=no)
      --enable-FEATURE[=ARG]  include FEATURE [ARG=yes]
      --enable-serial         Specify whether to enable a fake mpi library to run
                              in serial mode.

    Optional Packages:
      --with-PACKAGE[=ARG]    use PACKAGE [ARG=yes]
      --without-PACKAGE       do not use PACKAGE (same as --with-PACKAGE=no)
      --with-psblas           The source directory for PSBLAS, for example,
                              --with-psblas=/opt/packages/psblas-2.3
      --with-libs             List additional link flags here. For example,
                              --with-libs=-lspecial_system_lib or
                              --with-libs=-L/path/to/libs
      --with-umfpack=LIBNAME  Specify the library name for UMFPACK library.
                              Default: "-lumfpack -lamd"
      --with-umfpackdir=DIR   Specify the directory for UMFPACK library and
                              includes.
      --with-superlu=LIBNAME  Specify the library name for SUPERLU library.
                              Default: "-lsuperlu"
      --with-superludir=DIR   Specify the directory for SUPERLU library and
                              includes.
      --with-superludist=LIBNAME
                              Specify the libname for SUPERLUDIST library.
                              Requires you also specify SuperLU. Default:
                              "-lsuperlu_dist"
      --with-superludistdir=DIR
                              Specify the directory for SUPERLUDIST library and
                              includes.

    Some influential environment variables:
      FC          Fortran compiler command
      FCFLAGS     Fortran compiler flags
      LDFLAGS     linker flags, e.g. -L<lib dir> if you have libraries in a
                  nonstandard directory <lib dir>
      LIBS        libraries to pass to the linker, e.g. -l<library>
      CC          C compiler command
      CFLAGS      C compiler flags
      CPPFLAGS    (Objective) C/C++ preprocessor flags, e.g. -I<include dir> if
                  you have headers in a nonstandard directory <include dir>
      CPP         C preprocessor
      MPICC       MPI C compiler command
      F77         Fortran 77 compiler command
      FFLAGS      Fortran 77 compiler flags
      MPIF77      MPI Fortran 77 compiler command
      MPIFC       MPI Fortran compiler command

    Use these variables to override the choices made by `configure' or to help
    it to find libraries and programs with nonstandard names/locations.

    Report bugs to <bugreport@mld2p4.it>.

Thus, a sample build with libraries in installation directories specifics to the GNU 4.7 compiler suite might be as follows, specifying only the UMFPACK external package:

     ./configure --with-psblas=/home/user/psblas-3.1/ \
     --with-libs="-L/usr/local/BLAS/gnu47" \
     --with-umfpackdir=/usr/local/UMFPACK/gnu47

Once the configure script has completed execution, it will have generated the file `Make.inc` which will then be used by all Makefiles in the directory tree; this file will be copied in the install directory under the name `Make.inc.MLD2P4`.

To build the library the user will now enter

    make

followed (optionally) by

    make install